#include "miccreatetemplate.h"
#include "mainwindow.h"
#include "ui_mainwindow.h"
#include "common.h"



MICcreateTemplate::MICcreateTemplate(QWidget *parent) :
    QMainWindow(parent)
{
}




//---------------------------------------------------------//
//
//---------------------------------------------------------//
void MainWindow::MICcreateTemplate()
{

    try
    {

        qDebug("MICcreateTemplate START [%s][%d]\n" , __FILE__, __LINE__ );

        double elvfrom    = 0; // 仰角開始
        double elvint     = 0; // 仰角間隔
        double elvto      = 0;
        int numelv        = 0; // 仰角数

        double heightfrom =0; // 高さ開始
        double heightto   = 0 ;
        double heightint  = 0 ; // 高さ間隔

        double hcount     = 0;
        double tcount     = 0;

        double azifrom    = 0; //方位角
        double azito      = 0;
        double aziint     = 0;

        int numheight     = 0;  // 高さ数
        int result        = -1; // 戻り値



        //--------------------------------------------------------//
        // 球面座標 or 円柱座標 check
        //--------------------------------------------------------//
        int coordinate = 0;

        if (ui->mic_spherical->isChecked()) //球面座標?
        {
            coordinate = 0; //球面座標
        }
        else
        {
            coordinate = 1; //円柱座標
        }



        //--------------------------------------------------------//
        // radius(距離)
        //--------------------------------------------------------//
        double radius = ui->mic_radiusfrom->value();



        switch(coordinate)
        {
        //------------------------------------------------------------//
        //  球面座標                                                  //
        //------------------------------------------------------------//
        case 0:
            {
                //--------------------------------------------------------//
                // elevation(仰角)
                //--------------------------------------------------------//
                elvfrom = ui->mic_elvfrom->value(); // 仰角開始
                elvto   = ui->mic_elvto->value();   // 仰角終了
                elvint  = ui->mic_elvint->value();  // 仰角間隔

                if( elvto != elvfrom)
                {
                    tcount = (elvto - elvfrom) / elvint;
                }

                numelv = ( (int)ceil(tcount) ) +1; //切り上げ  // 仰角数

                qDebug("elvfrom[%f] elvint[%f] numelv[%d]\n", elvfrom,  elvint , numelv);

                break;
            }
        //------------------------------------------------------------//
        //  円柱座標                                                  //
        //------------------------------------------------------------//
        case 1:
            {
                //--------------------------------------------------------//
                // height(高さ)
                //--------------------------------------------------------//
                heightfrom = ui->mic_heightfrom->value(); // 高さ開始
                heightto   = ui->mic_heightto->value();
                heightint  = ui->mic_heightint->value(); // 高さ間隔

                if(heightto != heightfrom)
                {
                    hcount = double((heightto*1000) - (heightfrom*1000)) / (heightint*1000);
                }

                numheight = ((int)ceil(hcount)) + 1;//切りあげ // 高さ数


                qDebug("heightfrom[%f] heightint[%f] numheight[%d]\n", heightfrom,  heightint , numheight);

                break;
            }

        }//switch


        //--------------------------------------------------------//
        // AZIMUTH(方位角)
        //--------------------------------------------------------//
         azifrom = ui->mic_azifrom->value(); // 方位角開始
         azito   = ui->mic_azito->value();   // 方位角終了

        if(azifrom >= azito)
        {
            azifrom = azifrom - 360;
        }

         aziint = ui->mic_aziint->value(); //方位角間隔

        double fcount = double(azito - azifrom) / aziint;
        int count= (int)fcount + 1;

        int numazi     = count;    // 方位角数


        // 一時ディレクトリを生成
        boost::filesystem::path temp_dir = CreateTemporaryDirectory();
        boost::filesystem::path hark_config_file_path = temp_dir / "MicArrayLocationFile.xml";

        qDebug() << "hark_config_file_path.c_str() =" << hark_config_file_path.c_str() ;



        switch(coordinate)
        {
            //------------------------------------------------------------//
            //  球面座標(仰角)                                             //
            //------------------------------------------------------------//
            case 0:
            {
                qDebug("*---------------------------------------------------------*\n");
                qDebug( "harktool4_cui \n "
                                "--mode template\n"
                                "--output-file %s\n"
                                "--output-format xml\n"
                                "--output-type mic\n"
                                "--azifrom %f\n"
                                "--aziint %f\n"
                                "--numazi %d\n"
                                "--elvfrom %f\n"
                                "--elvint %f\n"
                                "--numelv %d\n"
                                "--radius %f \n"
                        ,"MicArrayLocationFile.xml"
                        , azifrom   //azifrom
                        , aziint    //aziint
                        , numazi    //numazi
                        , elvfrom   //elvfrom
                        , elvint    //elvint
                        , numelv   //numelv
                        , radius    //radius
                      );
                qDebug("*---------------------------------------------------------*\n");

                // MicArrayLocationFileを作成
                result = ::system((boost::format("harktool4_cui "
                                                    "--mode template "
                                                    "--output-file %s "
                                                    "--output-format xml "
                                                    "--output-type mic "
                                                    "--azifrom %f --aziint %f --numazi %d "
                                                    "--elvfrom %f --elvint %f --numelv %d "
                                                    "--radius %f "
                                                    )
                                                    % hark_config_file_path
                                                    % azifrom % aziint % numazi
                                                    % elvfrom % elvint  % numelv
                                                    % radius).str().c_str());


                break;
            }
            //------------------------------------------------------------//
            //  円柱座標(高さ使用)                                         //
            //------------------------------------------------------------//
            case 1:
            {
                qDebug("*---------------------------------------------------------*\n");
                qDebug( "harktool4_cui \n "
                                "--mode template\n"
                                "--output-file %s\n"
                                "--output-format xml\n"
                                "--output-type mic\n"
                                "--azifrom %f\n "
                                "--aziint %f\n "
                                "--numazi %d\n "
                                "--heightfrom %f\n"
                                "--heightint %f\n "
                                "--numheight %d\n"
                                "--radius %f \n"

                                ,"MicArrayLocationFile.xml"
                                , azifrom            //azifrom
                                , aziint        //aziint
                                , numazi           //numazi
                                , heightfrom     //heightfrom
                                , heightint //heightint
                                , numheight   //numheight
                                , radius          //radius
                    );
                qDebug("*---------------------------------------------------------*\n");


                // MicArrayLocationFileを作成
                result = ::system((boost::format("harktool4_cui "
                                                    "--mode template "
                                                    "--output-file %s "
                                                    "--output-format xml "
                                                    "--output-type mic "
                                                    "--azifrom %f --aziint %f --numazi %d "
                                                    "--heightfrom %f --heightint %f --numheight %d "
                                                    "--radius %f "
                                                    )
                                                    % hark_config_file_path
                                                    % azifrom % aziint % numazi
                                                    % heightfrom % heightint % numheight
                                                    % radius).str().c_str());


                break;
            }
        }//switch

        if (result != 0)
        {
            THROW_CRITICAL(trUtf8("harktool4_cuiコマンドを正常に実行できませんでした"));
            return;
        }


        //-----------------------------------------------------//
        //  xmlファイルを整形する
        //-----------------------------------------------------//
        ::system((boost::format("tidy -o %s -xml -utf8 -w 255 -c -q -asxml -i %s ")
                                % hark_config_file_path.c_str()
                                % hark_config_file_path.c_str()).str().c_str());


        QFile hark_config(hark_config_file_path.c_str());

        if (!hark_config.open(QIODevice::ReadOnly))
        {
            THROW_CRITICAL(trUtf8("作成したファイルを読み込めませんでした"));
        }

        QTextStream inbuf(&hark_config);
        QString outbuf = inbuf.readAll();
        qDebug() << outbuf;
        ui->mic_textEdit->setStyleSheet(" color: white;font: bold 16px;");
        ui->mic_textEdit->setText(outbuf);

        qDebug() << "harktool4_cui Ok" ;


        //-----------------------------------------------------------------//
        // hark_config_file_pathを格納する
        //-----------------------------------------------------------------//
        m_plotctl[m_out_page_no].mic_hark_path = hark_config_file_path;


    }
    catch (std::exception& exp)
    {
        THROW_CRITICAL(exp.what());
        return;
    }

return;

}
